vsg: vsg::CpuLayoutTechnique Class Reference

vsg 1.1.10 VulkanSceneGraph library |

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
vsg::CpuLayoutTechnique Class Reference
Inheritance diagram for vsg::CpuLayoutTechnique:
[legend]
Collaboration diagram for vsg::CpuLayoutTechnique:
[legend]

## Public Member Functions
void | traverse (Visitor &visitor) override
void | traverse (ConstVisitor &visitor) const override
void | traverse (RecordTraversal &visitor) const override
void | setup (Text *text, uint32_t minimumAllocation=0, ref_ptr< const Options > options={}) override
void | setup (TextGroup *textGroup, uint32_t minimumAllocation=0, ref_ptr< const Options > options={}) override
dbox | extents () const override
virtual ref_ptr< Node > | createRenderingSubgraph (ref_ptr< ShaderSet > shaderSet, ref_ptr< Font > font, bool billboard, TextQuads &textQuads, uint32_t minimumAllocation)
Public Member Functions inherited from vsg::Inherit< TextTechnique, CpuLayoutTechnique >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
int | compare (const Object &rhs) const override
void | accept (Visitor &visitor) override
void | accept (ConstVisitor &visitor) const override
void | accept (RecordTraversal &visitor) const override
Public Member Functions inherited from vsg::Inherit< Object, TextTechnique >
| Inherit (Args &&... args)
Public Member Functions inherited from vsg::Object
| Object (const Object &object, const CopyOp &copyop={})
Object & | operator= (const Object &)
template<class T>
T * | cast ()
template<class T>
const T * | cast () const
virtual ref_ptr< Object > | clone (const CopyOp &copyop={}) const
virtual void | read (Input &input)
virtual void | write (Output &output) const
void | ref () const noexcept
void | unref () const noexcept
void | unref_nodelete () const noexcept
unsigned int | referenceCount () const noexcept
template<typename T>
void | setValue (const std::string &key, const T &value)
void | setValue (const std::string &key, const char *value)
| specialization of setValue to handle passing C strings
template<typename T>
bool | getValue (const std::string &key, T &value) const
| get specified value type, return false if value associated with key is not assigned or is not the correct type
void | setObject (const std::string &key, ref_ptr< Object > object)
| assign an Object associated with key
Object * | getObject (const std::string &key)
| get Object pointer associated with key, return nullptr if no object associated with key has been assigned
const Object * | getObject (const std::string &key) const
| get const Object pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
T * | getObject (const std::string &key)
| get object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const T * | getObject (const std::string &key) const
| get const object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< Object > | getRefObject (const std::string &key)
| get ref_ptr<Object> associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< const Object > | getRefObject (const std::string &key) const
| get ref_ptr<const Object> pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
ref_ptr< T > | getRefObject (const std::string &key)
| get ref_ptr<T> of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const ref_ptr< const T > | getRefObject (const std::string &key) const
| get ref_ptr<const T> of specified type associated with key, return nullptr if no object associated with key has been assigned
void | removeObject (const std::string &key)
| remove meta object or value associated with key
Auxiliary * | getOrCreateAuxiliary ()
Auxiliary * | getAuxiliary ()
const Auxiliary * | getAuxiliary () const

## Static Public Member Functions
template<class N, class V>
static void | t_traverse (N &node, V &visitor)
Static Public Member Functions inherited from vsg::Inherit< TextTechnique, CpuLayoutTechnique >
static ref_ptr< CpuLayoutTechnique > | create (Args &&... args)
static ref_ptr< CpuLayoutTechnique > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Inherit< Object, TextTechnique >
static ref_ptr< TextTechnique > | create (Args &&... args)
static ref_ptr< TextTechnique > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Object
static ref_ptr< Object > | create ()
static ref_ptr< Object > | create_if (bool flag)
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_AFFINTY_OBJECTS
static void | operator delete (void *ptr)

## Public Attributes
dbox | textExtents
ref_ptr< Node > | scenegraph
ref_ptr< vec3Array > | vertices
ref_ptr< vec4Array > | colors
ref_ptr< vec4Array > | outlineColors
ref_ptr< floatArray > | outlineWidths
ref_ptr< vec3Array > | texcoords
ref_ptr< vec4Array > | centerAndAutoScaleDistances
ref_ptr< Data > | indices
ref_ptr< DrawIndexed > | drawIndexed
ref_ptr< BindVertexBuffers > | bindVertexBuffers
ref_ptr< BindIndexBuffer > | bindIndexBuffer

## Additional Inherited Members
Protected Member Functions inherited from vsg::Object
virtual void | _attemptDelete () const
void | setAuxiliary (Auxiliary *auxiliary)

## Member Function Documentation

## ◆ extents()

dbox vsg::CpuLayoutTechnique::extents | ( |  | ) | const
| inlineoverridevirtual

Implements vsg::TextTechnique.

## ◆ setup() [1/2]

void vsg::CpuLayoutTechnique::setup | ( | Text * | text,
|  | uint32_t | minimumAllocation = 0,
|  | ref_ptr< const Options > | options = {} )
| overridevirtual

Implements vsg::TextTechnique.

## ◆ setup() [2/2]

void vsg::CpuLayoutTechnique::setup | ( | TextGroup * | textGroup,
|  | uint32_t | minimumAllocation = 0,
|  | ref_ptr< const Options > | options = {} )
| overridevirtual

Implements vsg::TextTechnique.

## ◆ traverse() [1/3]

void vsg::CpuLayoutTechnique::traverse | ( | ConstVisitor & | visitor | ) | const
| inlineoverridevirtual

Reimplemented from vsg::Object.

## ◆ traverse() [2/3]

void vsg::CpuLayoutTechnique::traverse | ( | RecordTraversal & | visitor | ) | const
| inlineoverridevirtual

Reimplemented from vsg::Object.

## ◆ traverse() [3/3]

void vsg::CpuLayoutTechnique::traverse | ( | Visitor & | visitor | ) |
| inlineoverridevirtual

Reimplemented from vsg::Object.

The documentation for this class was generated from the following file:

- include/vsg/text/CpuLayoutTechnique.h